#########################
##Author: Suhas.B AWS 
#########################
version: '3.8'
services:
  postgres_master:
    image: pgconf_user/pgdatabase
    container_name: postgres_master
    env_file:
      - ./.env
    environment:
      - POSTGRES_USERNAME=${PG_USERNAME}
      - POSTGRES_PASSWORD=${PG_PASSWORD}
      - POSTGRES_DB=${PG_DATABASE}
      - POSTGRES_HOST_AUTH_METHOD=${POSTGRES_HOST_AUTH_METHOD}
      - POSTGRES_INITDB_ARGS=${POSTGRES_INITDB_ARGS}
    ports:
      - '5432:5432'
    volumes:
      - ./postgres-data:/var/lib/postgresql/data
      # copy the sql script to create tables
      - ./sql/create_replication_user.sql:/docker-entrypoint-initdb.d/create_replication_user.sql
      - ./sql/pgconf.sql:/docker-entrypoint-initdb.d/pgconf.sql
      - ./sql/pgtoolkit.sql:/docker-entrypoint-initdb.d/pgtoolkit.sql
      - ./sql/sample_sql.sql:/docker-entrypoint-initdb.d/sample_sql.sql
      - ./config/postgresql.conf:/var/lib/config/postgresql.conf
      - ./config/check_postgres-2.26.0.tar.gz:/var/lib/scripts/check_postgres-2.26.0.tar.gz
      - ./sql/pg_health_check.sql:/var/lib/scripts/pg_health_check.sql
    command: postgres -c config_file=/var/lib/config/postgresql.conf
    restart: always
    networks:
      - postgres_master
  postgres_replica:
    image: pgconf_user/pgdatabase
    container_name: postgres_replica
    ports:
      - 5433:5433
    env_file:
      - ./.env
    environment:
      - POSTGRES_USERNAME=${PG_USERNAME}
      - POSTGRES_PASSWORD=${PG_PASSWORD}
      - PGUSER=${REP_USER}
      - PGPASSWORD={REP_PASSWORD}
    volumes:
      - ./config/postgresql_rep.conf:/var/lib/config/postgresql.conf
      - ./slave_setup.sh:/docker-entrypoint-initdb.d/slave_setup.sh
    command: postgres -c config_file=/var/lib/config/postgresql.conf
    networks:
      - postgres_master
    depends_on:
      - postgres_master
  plprofiler:
    image: pythonconfuser/plprofiler
    container_name: plprofiler
    networks:
      - postgres_master
    depends_on:
      - postgres_master
networks:
  postgres_master:
    driver: bridge
